
@INPROCEEDINGS{6698889, 
author={Galeotti, J.P. and Fraser, G. and Arcuri, A}, 
booktitle={Software Reliability Engineering (ISSRE), 2013 IEEE 24th International Symposium on}, 
title={Improving search-based test suite generation with dynamic symbolic execution}, 
year={2013}, 
month={Nov}, 
pages={360-369}, 
}

@book{Sheskin:2007:HPN:1529939,
 author = {Sheskin, David J.},
 title = {Handbook of Parametric and Nonparametric Statistical Procedures},
 year = {2007},
 isbn = {1584888148, 9781584888147},
 edition = {4},
 publisher = {Chapman \& Hall/CRC},
}

@book{Manning:2008:IIR:1394399,
 author = {Manning, Christopher D. and Raghavan, Prabhakar and Sch\"{u}tze, Hinrich},
 title = {Introduction to Information Retrieval},
 year = {2008},
 isbn = {0521865719, 9780521865715},
 publisher = {Cambridge University Press},
 address = {New York, NY, USA},
} 


@inproceedings{Islam:2010:DTC:1868321.1868326,
 author = {Islam, Mainul and Csallner, Christoph},
 title = {Dsc+Mock: A Test Case + Mock Class Generator in Support of Coding Against Interfaces},
 booktitle = {Proceedings of the Eighth International Workshop on Dynamic Analysis},
 series = {WODA '10},
 year = {2010},
 isbn = {978-1-4503-0137-4},
 location = {Trento, Italy},
 pages = {26--31},
 numpages = {6},
 url = {http://doi.acm.org/10.1145/1868321.1868326},
 doi = {10.1145/1868321.1868326},
 acmid = {1868326},
 publisher = {ACM},
 address = {New York, NY, USA},
 keywords = {dynamic symbolic execution, method body generation, mock class generation, test case generation},
} 

@inproceedings{Pacheco:2008:FEN:1390630.1390643,
 author = {Pacheco, Carlos and Lahiri, Shuvendu K. and Ball, Thomas},
 title = {Finding Errors in .Net with Feedback-directed Random Testing},
 booktitle = {Proceedings of the 2008 International Symposium on Software Testing and Analysis},
 series = {ISSTA '08},
 year = {2008},
 isbn = {978-1-60558-050-0},
 location = {Seattle, WA, USA},
 pages = {87--96},
 numpages = {10},
 url = {http://doi.acm.org/10.1145/1390630.1390643},
 doi = {10.1145/1390630.1390643},
 acmid = {1390643},
 publisher = {ACM},
 address = {New York, NY, USA},
 keywords = {random testing},
} 


@article{Chen:2001:PSS:544998.545004,
 author = {Chen, T. Y. and Tse, T. H. and Yu, Y. T.},
 title = {Proportional Sampling Strategy: A Compendium and Some Insights},
 journal = {J. Syst. Softw.},
 issue_date = {August 2001},
 volume = {58},
 number = {1},
 month = aug,
 year = {2001},
 pages = {65--81},
 address = {New York, NY, USA},
}


@inproceedings{Lin:2009:DAA:1747491.1747522,
 author = {Lin, Yu and Tang, Xucheng and Chen, Yuting and Zhao, Jianjun},
 title = {A Divergence-Oriented Approach to Adaptive Random Testing of Java Programs},
 booktitle = {Proceedings of the 2009 IEEE/ACM International Conference on Automated Software Engineering},
 series = {ASE '09},
 year = {2009},
 pages = {221--232},
 address = {Washington, DC, USA},
} 


@inproceedings{Forrester:2000:ESR:1267102.1267108,
 author = {Forrester, Justin E. and Miller, Barton P.},
 title = {An Empirical Study of the Robustness of Windows NT Applications Using Random Testing},
 booktitle = {Proceedings of the 4th Conference on USENIX Windows Systems Symposium - Volume 4},
 series = {WSS'00},
 year = {2000},
 pages = {59--68},
 address = {Seattle, Washington}
} 

@inproceedings{Oriat:2005:JTR:2101069.2101097,
 author = {Oriat, Catherine},
 title = {Jartege: A Tool for Random Generation of Unit Tests for Java Classes},
 booktitle = {Proceedings of the First International Conference on Quality of Software Architectures and Software Quality, and Proceedings of the Second International Conference on Software Quality},
 series = {QoSA'05},
 year = {2005},
  address = {Erfurt, Germany},
} 


@book{Ammann:2008:IST:1355340,
 author = {Ammann, Paul and Offutt, Jeff},
 title = {Introduction to Software Testing},
 year = {2008},
 edition = {1},
 publisher = {Cambridge University Press},
 address = {New York, NY, USA},
}

@inproceedings{Park:2012:CAH:2393596.2393636,
 author = {Park, Sangmin and Hossain, B. M. Mainul and Hussain, Ishtiaque and Csallner, Christoph and Grechanik, Mark and Taneja, Kunal and Fu, Chen and Xie, Qing},
 title = {CarFast: Achieving Higher Statement Coverage Faster},
 booktitle = {Proceedings of the ACM SIGSOFT 20th International Symposium on the Foundations of Software Engineering},
 series = {FSE '12},
 year = {2012},
 location = {Cary, North Carolina},
 pages = {35:1--35:11},
 numpages = {11},
 address = {Cary, North Carolina},
} 

@inproceedings{Arcuri:2011:ART:2001420.2001452,
 author = {Arcuri, Andrea and Briand, Lionel},
 title = {Adaptive Random Testing: An Illusion of Effectiveness?},
 booktitle = {Proceedings of the 2011 International Symposium on Software Testing and Analysis},
 series = {ISSTA '11},
 year = {2011},
 location = {Toronto, Ontario, Canada},
 pages = {265--275},
 address = {Toronto, Ontario, Canada}
} 

@article{Jia:2011:ASD:2052439.2052494,
 author = {Jia, Yue and Harman, Mark},
 title = {An Analysis and Survey of the Development of Mutation Testing},
 journal = {IEEE Trans. Softw. Eng.},
 issue_date = {September 2011},
 volume = {37},
 number = {5},
 month = sep,
 year = {2011},
 pages = {649--678}
} 


@inproceedings{Galeotti:2014:EST:2610384.2628049,
 author = {Galeotti, Juan Pablo and Fraser, Gordon and Arcuri, Andrea},
 title = {Extending a Search-based Test Generator with Adaptive Dynamic Symbolic Execution},
 booktitle = {Proceedings of the 2014 International Symposium on Software Testing and Analysis},
 series = {ISSTA 2014},
 year = {2014},
 pages = {421--424},
 publisher = {ACM},
 address = {San Jose, CA, USA},
}


@inproceedings{Winkler:2012:IUC:2368323.2368352,
 author = {Winkler, Dietmar and Schmidt, Martina and Ramler, Rudolf and Biffl, Stefan},
 title = {Improving Unfamiliar Code with Unit Tests: An Empirical Investigation on Tool-supported and Human-based Testing},
 booktitle = {Proceedings of the 13th International Conference on Product-Focused Software Process Improvement},
 series = {PROFES'12},
 year = {2012},
 isbn = {978-3-642-31062-1},
 location = {Madrid, Spain},
 pages = {290--304},
 numpages = {15},
 url = {http://dx.doi.org/10.1007/978-3-642-31063-8_22},
 doi = {10.1007/978-3-642-31063-8_22},
 acmid = {2368352},
 publisher = {Springer-Verlag},
 address = {Berlin, Heidelberg},
 keywords = {controlled experiment, manual and tool-supported tests, random test case generation, software product improvement, software testing},
}



@inproceedings{Yi:2013:ECI:2483760.2483772,
 author = {Yi, Jooyong and Qi, Dawei and Tan, Shin Hwei and Roychoudhury, Abhik},
 title = {Expressing and Checking Intended Changes via Software Change Contracts},
 booktitle = {Proceedings of the 2013 International Symposium on Software Testing and Analysis},
 series = {ISSTA 2013},
 year = {2013},
 isbn = {978-1-4503-2159-4},
 location = {Lugano, Switzerland},
 pages = {1--11},
 numpages = {11},
 url = {http://doi.acm.org/10.1145/2483760.2483772},
 doi = {10.1145/2483760.2483772},
 acmid = {2483772},
 publisher = {ACM},
 address = {New York, NY, USA},
 keywords = {Dynamic checking, Software changes, Test generation, Test repair},
} 


@inproceedings{Inkumsah:2008:IST,
 author = {Inkumsah, K. and Tao Xie},
 title = {Improving Structural Testing of Object-Oriented Programs via Integrating Evolutionary Testing and Symbolic Execution},
 booktitle = {Proceedings of the 2008 23rd IEEE/ACM International Conference on Automated Software Engineering},
 series = {ASE '08},
 year = {2008},
 isbn = {978-1-4244-2187-9},
 pages = {297--306},
 address = {Washington, DC, USA},
} 

@inproceedings{conf/kbse/RobinsonEPAL11,
  added-at = {2011-12-14T00:00:00.000+0100},
  author = {Robinson, Brian and Ernst, Michael D. and Perkins, Jeff H. and Augustine, Vinay and Li, Nuo},
  biburl = {http://www.bibsonomy.org/bibtex/269fcce894bcaa2a5d133eb0a538f5f5a/dblp},
 booktitle = {Proceedings of the 2011 26th IEEE/ACM International Conference on Automated Software Engineering},
 series = {ASE '11},
  editor = {Alexander, Perry and Pasareanu, Corina S. and Hosking, John G.},
  ee = {http://dx.doi.org/10.1109/ASE.2011.6100059},
  interhash = {68d36530bf342d16ba318e213e4c4274},
  intrahash = {69fcce894bcaa2a5d133eb0a538f5f5a},
  isbn = {978-1-4577-1638-6},
  keywords = {dblp},
  pages = {23-32},
  publisher = {IEEE},
  timestamp = {2011-12-14T00:00:00.000+0100},
  title = {Scaling up automated test generation: Automatically generating maintainable regression unit tests for programs.},
  url = {http://dblp.uni-trier.de/db/conf/kbse/ase2011.html#RobinsonEPAL11},
  year = 2011
}

@article{Miller1963,
  acmid = {366248},
  added-at = {2012-02-25T06:16:41.000+0100},
  address = {New York, NY, USA},
  author = {Miller, Joan C. and Maloney, Clifford J.},
  biburl = {http://www.bibsonomy.org/bibtex/29d3eaa03eeafe38ecc562b9779dde81a/rhatko},
  description = {Systematic mistake analysis of digital computer programs},
  doi = {10.1145/366246.366248},
  groups = {public},
  interhash = {90dae2572467af9487f88596ac952db0},
  intrahash = {9d3eaa03eeafe38ecc562b9779dde81a},
  issn = {0001-0782},
  issue = {2},
  journal = {Commun. ACM},
  keywords = {coverage software_engineering},
  numpages = {6},
  pages = {58--63},
  publisher = {ACM},
  timestamp = {2012-02-25T06:16:41.000+0100},
  title = {Systematic mistake analysis of digital computer programs},
  url = {http://doi.acm.org/10.1145/366246.366248},
  username = {rhatko},
  volume = 6,
  year = 1963
}

@inproceedings{ramler2012,
author = {R. Ramler and D. Winkler and M. Schmidt},
title = {Random Test Case Generation and Manual Unit Testing: Substitute or Complement in Retrofitting Tests for Legacy Code?},
booktitle ={36th Conf.\ on Software Engineering and Advanced Applications},
year = {2012},
pages = {286--293},
publisher = {IEEE Computer Society},
}

@inproceedings{Calikli:2010:EAF:1868328.1868344,
 author = {Calikli, G. and Bener, A.},
 title = {Empirical analyses of the factors affecting confirmation bias and the effects of confirmation bias on software developer/tester performance},
 booktitle = {Proc.\ 6th Int.\ Conf.\ on Predictive Models in Software Engineering},
 series = {PROMISE~2010},
 year = {2010},
 isbn = {978-1-4503-0404-7},
 location = {Timi\&scedil;oara, Romania},
 pages = {10:1--10:11},
 articleno = {10},
 numpages = {11},
 url = {http://doi.acm.org/10.1145/1868328.1868344},
 doi = {10.1145/1868328.1868344},
 acmid = {1868344},
 publisher = {ACM},
 address = {New York, NY, USA},
 keywords = {cognitive biases, confirmation bias, software engineering, software testing},
}

@article{10.1109/TSE.1976.233837,
author = {T.J. McCabe},
title = {A Complexity Measure},
journal ={IEEE Transactions on Software Engineering},
volume = {2},
number = {4},
issn = {0098-5589},
year = {1976},
pages = {308-320},
doi = {http://doi.ieeecomputersociety.org/10.1109/TSE.1976.233837},
publisher = {IEEE Computer Society},
address = {Los Alamitos, CA, USA},
}

@article{Godefroid:2005:DDA:1064978.1065036,
 author = {Godefroid, P. and Klarlund, N. and Sen, K.},
 title = {DART: directed automated random testing},
 journal = {SIGPLAN Not.},
 issue_date = {June 2005},
 volume = {40},
 number = {6},
 month = jun,
 year = {2005},
 issn = {0362-1340},
 pages = {213--223},
 numpages = {11},
 url = {http://doi.acm.org/10.1145/1064978.1065036},
 doi = {10.1145/1064978.1065036},
 acmid = {1065036},
 publisher = {ACM},
 address = {New York, NY, USA},
 keywords = {automated test generation, interfaces, program verification, random testing, software testing},
} 

@article{Sen:2005:CCU:1095430.1081750,
 author = {Sen, K. and Marinov, D. and Agha, G.},
 title = {{CUTE}: a concolic unit testing engine for {C}},
 journal = {SIGSOFT Softw. Eng. Notes},
 issue_date = {September 2005},
 volume = {30},
 number = {5},
 month = sep,
 year = {2005},
 issn = {0163-5948},
 pages = {263--272},
 numpages = {10},
 url = {http://doi.acm.org/10.1145/1095430.1081750},
 doi = {10.1145/1095430.1081750},
 acmid = {1081750},
 publisher = {ACM},
 address = {New York, NY, USA},
 keywords = {concolic testing, data structure testing, explicit path model-checking, random testing, testing C programs, unit testing},
}

@Book{GammaETAL95DesignPatterns,
  author =       {E. Gamma and R. Helm and R. Johnson and J. Vlissides},
  title =        {Design Patterns: Elements of Reusable Object-Oriented Software},
  year =         1995,
  publisher =    {{Addison-Wesley} Publishing Company},
  series =       {{Addison-Wesley} Professional Computing Series},
  address =      {New York, USA}
}

@book{myers79,
 author = {G. Myers},
 title = {Art of Software Testing},
 year = {1979},
 publisher = {John Wiley \& Sons, Inc.},
}

@inproceedings{Pacheco:2007:RFR:1297846.1297902,
 author = {Pacheco, C. and Ernst, M.},
 title = {Randoop: Feedback-directed Random Testing for {Java}},
 booktitle = {Companion to the 22nd ACM SIGPLAN Conf.\ on Object-oriented Programming Systems and Applications Companion},
 series = {OOPSLA~2007},
 year = {2007},
 isbn = {978-1-59593-865-7},
 address = {Montreal, Canada},
 pages = {815--816},
 numpages = {2},
 acmid = {1297902},
 publisher = {ACM},
 keywords = {Java, automatic test generation, random testing},
} 

@INPROCEEDINGS{Artho:2006ub,
  author = {Artho, Cyrille and Garoche, Pierre-Loic},
  title = {{Accurate Centralization for Applying Model Checking on Networked
     Applications}},
  booktitle = {Proc. the 21st IEEE/ACM Int'l Conf. Autom. Softw. Eng.},
  address = {Washington, DC, USA},
  month = sep,
  year = {2006},
 pages = {177--188}
}

@INPROCEEDINGS{Artho:2009gc,
 author = {Artho, Cyrille and Leungwattanakit, Watcharin and Hagiya, Masami and Tanabe, Yoshinori and Yamamoto,   
 Mitsuharu},
 title = {Cache-Based Model Checking of Networked Applications: From Linear to Branching Time},
 booktitle = {Proc. the 2009 IEEE/ACM Int'l Conf. Autom. Softw. Eng.},
 address = {Washington, DC, USA},
 year = {2009},
 pages = {447--458},
}


@BOOK{Borghoff:2000:CCW:556699,
  author = {Borghoff, Uwe M. and Schlichter, J. H.},
  title = {Computer-Supported Cooperative Work: Introduction to Distributed
     Applications},
  publisher = {Springer-Verlag New York, Inc.},
  address = {Secaucus, NJ, USA},
  year = {2000}
}

@INPROCEEDINGS{Bruneton02asm:a,
  author = {Bruneton, Eric and Lenglet, Romain and Coupaye, Thierry},
  title = {{ASM: A code manipulation tool to implement adaptable systems}},
  booktitle = {In Adaptable and extensible component systems},
  year = {2002}
}


@BOOK{Goetz:2006wk,
  title = {{Java Concurrency in Practice}},
  publisher = {Addison-Wesley Professional},
  year = {2006},
  author = {Goetz, Brian and Peierls, Tim and Bloch, Joshua and Bowbeer, Joseph
     and Holmes, David and Lea, Doug}
}

@BOOK{Gosling:2000uz,
 author = {Gosling, James and Joy, Bill and Steele, Guy and Bracha, Gilad},
 title = {Java(TM) Language Specification, The (3rd Edition)},
 publisher = {Addison-Wesley Professional},
 year = {2005},
}


@MISC{Toolkit:ZTAjaZ1t,
  author = {{Java Runtime Analysis Toolkit}},
  title = {{http://jrat.sourceforge.net/}}
}

@MISC{Toolkit:Gnutime,
  author = {{GNU Time}},
  title = {{http://www.gnu.org/software/time/}}
}

@MISC{Toolkit:Randoop,
  author = {{Randoop\,1.3.4}},
  title = {{https://code.google.com/p/randoop/downloads/list}}
}

@MISC{Toolkit:Evosuite,
  author = {{Evosuite-20140724}},
  title = {{http://www.evosuite.org/downloads/}}
}

@MISC{Toolkit:GRT,
  author = {{GRT Additional Result}},
  title = {https://sites.google.com/site/grtprojectut/icse15/.}
}


@MISC{Toolkit:PIT,
  author = {{PIT 1.0.0}},
  title = {{http://pitest.org/}}
}

@MISC{Toolkit:CLOC,
  author = {{CLOC 1.60}},
  title = {{http://cloc.sourceforge.net/}}
}

@MISC{JAPI:V6,
  author = {{Java Platform, Standard Edition, V6 API Specification}},
  title = {http://docs.oracle.com/javase/6/docs/api/},
  owner = {malei},
  timestamp = {2013.03.26}
}

@MISC{JCarder:tk-35KSX,
  author = {{JCarder}},
  title = {{http://www.jcarder.org/}}
}

@MISC{JTRACERT:2013,
  author = {{Jtracert}},
  title = {{https://code.google.com/p/jtracert/}}
}


@MISC{Jacoco:2013,
  author = {{JaCoCo v0.6.4}},
  title = {{http://www.eclemma.org/jacoco/}}
}

@INPROCEEDINGS{Bruneton:2002tq,
    author = {Eric Bruneton and Romain Lenglet and Thierry Coupaye},
    title = {{ASM}: A code manipulation tool to implement adaptable systems},
    booktitle = {Adaptable and extensible component systems},
    address = {Grenoble, France},
    month = nov,
    year = 2002
}


@INPROCEEDINGS{Letko:2008fx,
  author = {Letko, Zden{\v e}k and Vojnar, Tom{\'a}{\v s} and K{\v r}ena, Bohuslav},
  title = {{AtomRace: data race and atomicity violation detector and healer}},
  booktitle = {PADTAD '08: Proceedings of the 6th workshop on Parallel and distributed
     systems: testing, analysis, and debugging},
  year = {2008},
  month = jul
}

@BOOK{Lindholm:1999vs,
  title = {{The Java{\texttrademark} Virtual Machine Specification (2nd Edition)}},
  publisher = {Addison-Wesley Professional},
  year = {1999},
  author = {Lindholm, Tim and Yellin, Frank},
  edition = {2}
}

@MISC{JPF:hp-03,
  author = {{NASA. Java PathFinder, 2013}},
  title = {{http://babelfish.arc.nasa.gov/trac/jpf/}}
}

@MISC{Serp:DTXFo3F7,
  author = {{Serp}},
  title = {{http://serp.sourceforge.net/}}
}

@ARTICLE{Shafiei:2012:MCL:2382756.2382800,
  author = {Shafiei, Nastaran and Mehlitz, Peter},
  title = {Modeling class loaders in Java PathFinder version 7},
  journal = {SIGSOFT Softw. Eng. Notes},
  volume = {37},
  month = nov,
  year = {2012},
  pages = "1-5",
 
}

@INPROCEEDINGS{Stoller:2001wy,
 author = {Stoller, Scott D. and Liu, Yanhong A.},
 title = {Transformations for model checking distributed {Java} programs},
 booktitle = {Proc. the 8th Int'l SPIN workshop on Model checking of software},
 address = {New York, NY, USA},
 year = {2001},
 pages = "192-199"
}



@ARTICLE{Visser:2003:MCP:641151.641186,
  author    = {Willem Visser and
               Klaus Havelund and
               Guillaume P. Brat and
               Seungjoon Park and
               Flavio Lerda},
  title     = {Model Checking Programs},
  journal   = {Autom. Softw. Eng.},
  volume    = {10},
  month     = apr,
  year      = {2003},
  pages     = {203-232},
}



% * Automatic test generation via method-sequence construction
% * Use return type information to construct input objects
@article {SPE:SPE602,
  author = {Csallner, Christoph and Smaragdakis, Yannis},
  title = {JCrasher: an automatic robustness tester for Java},
  journal = {Software: Practice and Experience},
  volume = {34},
  number = {11},
  publisher = {John Wiley & Sons, Ltd.},
  issn = {1097-024X},
  url = {http://dx.doi.org/10.1002/spe.602},
  doi = {10.1002/spe.602},
  pages = {1025--1050},
  keywords = {software testing, test case generation, random testing, Java, state re-initialization},
  year = {2004},
}

% * Fully automatic testing
% * Use contract (user-provided formal specification) to reveal errors
@inproceedings{ciupa2005automatic,
  title={Automatic testing based on design by contract},
  author={Ciupa, Ilinca and Leitner, Andreas},
  booktitle={Proceedings of Net. ObjectDays},
  volume={2005},
  pages={545--557},
  year={2005},
  organization={Citeseer},
}


% * Use feedback information to generate method call sequences
% * Use existing passing test cases to infer program execution models
@inproceedings{Pacheco:2005:EAG:2144892.2144921,
 author = {Pacheco, Carlos and Ernst, Michael D.},
 title = {Eclat: Automatic Generation and Classification of Test Inputs},
 booktitle = {Proceedings of the 19th European Conference on Object-Oriented Programming},
 series = {ECOOP'05},
 year = {2005},
 isbn = {3-540-27992-X, 978-3-540-27992-1},
 location = {Glasgow, UK},
 pages = {504--527},
 numpages = {24},
 acmid = {2144921},
 publisher = {Springer-Verlag},
 address = {Berlin, Heidelberg},
}


% * Use client code bases to assist random test generation and dynamic symbolic execution
@inproceedings{Thummalapenta:2009:MOU:1595696.1595725,
  author = {Thummalapenta, Suresh and Xie, Tao and Tillmann, Nikolai and de Halleux, Jonathan and Schulte, Wolfram},
  title = {MSeqGen: Object-oriented Unit-test Generation via Mining Source Code},
  booktitle = {Proceedings of the the 7th Joint Meeting of the European Software Engineering Conference and the ACM SIGSOFT Symposium on The Foundations of Software Engineering},
  series = {ESEC/FSE '09},
  year = {2009},
  isbn = {978-1-60558-001-2},
  location = {Amsterdam, The Netherlands},
  pages = {193--202},
  numpages = {10},
  url = {http://doi.acm.org/10.1145/1595696.1595725},
  doi = {10.1145/1595696.1595725},
  acmid = {1595725},
  publisher = {ACM},
  address = {New York, NY, USA},
  keywords = {object-oriented testing, sequence mining},
}

% * Basically, Randoop + MUT-aware sequence recommendation
% * MUT-aware sequence recommendation generates a small sequence which mutates the input object.
@inproceedings{Zheng:2010:RUG:1858996.1859054,
  author = {Zheng, Wujie and Zhang, Qirun and Lyu, Michael and Xie, Tao},
  title = {Random Unit-test Generation with MUT-aware Sequence Recommendation},
  booktitle = {Proceedings of the IEEE/ACM International Conference on Automated Software Engineering},
  series = {ASE '10},
  year = {2010},
  isbn = {978-1-4503-0116-9},
  location = {Antwerp, Belgium},
  pages = {293--296},
  numpages = {4},
  url = {http://doi.acm.org/10.1145/1858996.1859054},
  doi = {10.1145/1858996.1859054},
  acmid = {1859054},
  publisher = {ACM},
  address = {New York, NY, USA},
  keywords = {random testing},
}

% * Direct-manipulation
% * Use user-provided precondition to generate test inputs
% * Use user-provided postcondition as test oracles
@inproceedings{Boyapati:2002:KAT:566172.566191,
 author = {Boyapati, Chandrasekhar and Khurshid, Sarfraz and Marinov, Darko},
 title = {Korat: Automated Testing Based on {Java} Predicates},
 booktitle = {Proceedings of the 2002 ACM SIGSOFT International Symposium on Software Testing and Analysis},
 series = {ISSTA '02},
 year = {2002},
 isbn = {1-58113-562-9},
 location = {Roma, Italy},
 pages = {123--133},
 numpages = {11},
 url = {http://doi.acm.org/10.1145/566172.566191},
 doi = {10.1145/566172.566191},
 acmid = {566191},
 publisher = {ACM},
 address = {New York, NY, USA},
}

% * RUTE-J
% * GUI-based tool
@inproceedings{Andrews:2006:TSR:1145735.1145741,
  author = {Andrews, James H. and Haldar, Susmita and Lei, Yong and Li, Felix Chun Hang},
  title = {Tool Support for Randomized Unit Testing},
  booktitle = {Proceedings of the 1st International Workshop on Random Testing},
  series = {RT '06},
  year = {2006},
  isbn = {1-59593-457-X},
  location = {Portland, Maine},
  pages = {36--45},
  numpages = {10},
  url = {http://doi.acm.org/10.1145/1145735.1145741},
  doi = {10.1145/1145735.1145741},
  acmid = {1145741},
  publisher = {ACM},
  address = {New York, NY, USA},
  keywords = {randomized testing, unit testing},
}

% * Adaptive random testing
% * Use object-distance to produce evenly spread inputs
@inproceedings{Ciupa:2008:AAR:1368088.1368099,
 author = {Ciupa, Ilinca and Leitner, Andreas and Oriol, Manuel and Meyer, Bertrand},
 title = {ARTOO: Adaptive Random Testing for Object-oriented Software},
 booktitle = {Proceedings of the 30th International Conference on Software Engineering},
 series = {ICSE '08},
 year = {2008},
 isbn = {978-1-60558-079-1},
 location = {Leipzig, Germany},
 pages = {71--80},
 numpages = {10},
 url = {http://doi.acm.org/10.1145/1368088.1368099},
 doi = {10.1145/1368088.1368099},
 acmid = {1368099},
 publisher = {ACM},
 address = {New York, NY, USA},
 keywords = {adaptive random testing, object distance, software testing},
} 


% * Model-based random generation
% * Use JML to model software
@incollection{
  year={2005},
  isbn={978-3-540-29033-9},
  booktitle={Quality of Software Architectures and Software Quality},
  volume={3712},
  series={Lecture Notes in Computer Science},
  editor={Reussner, Ralf and Mayer, Johannes and Stafford, JudithA. and Overhage, Sven and Becker, Steffen and Schroeder, PatrickJ.},
  doi={10.1007/11558569_18},
  title={Jartege: A Tool for Random Generation of Unit Tests for {Java} Classes},
  url={http://dx.doi.org/10.1007/11558569_18},
  publisher={Springer Berlin Heidelberg},
  author={Oriat, Catherine},
  pages={242-256}
}




% * Reduce ART computation
@article{Chen20041001,
  title = "Mirror adaptive random testing ",
  journal = "Information and Software Technology ",
  volume = "46",
  number = "15",
  pages = "1001 - 1010",
  year = "2004",
  note = "Third International Conference on Quality Software: \{QSIC\} 2003 ",
  issn = "0950-5849",
  doi = "http://dx.doi.org/10.1016/j.infsof.2004.07.004",
  url = "http://www.sciencedirect.com/science/article/pii/S0950584904001107",
  author = "T.Y. Chen and F.-C. Kuo and R.G. Merkel and S.P. Ng",
  keywords = "Mirroring",
  keywords = "Adaptive random testing",
  keywords = "Random testing",
  keywords = "Black-box testing",
  keywords = "Test case selection",
  keywords = "Software testing "
}


@INPROCEEDINGS{Ham94,
   AUTHOR = {Richard Hamlet},
   TITLE = {Random Testing},
   EDITOR = {J. Marciniak}, 
   BOOKTITLE = {Encyclopedia of Software Engineering},
   PUBLISHER = {Wiley},
   YEAR = {1994},
   PAGES = {970-978}
}

@article{Luckow:2014:SPV:2557833.2560571,
 author = {Luckow, Kasper S. and P\u{a}s\u{a}reanu, Corina S.},
 title = {Symbolic PathFinder V7},
 journal = {SIGSOFT Softw. Eng. Notes},
 issue_date = {January 2014},
 volume = {39},
 number = {1},
 month = feb,
 year = {2014},
 issn = {0163-5948},
 pages = {1--5},
 numpages = {5},
 acmid = {2560571},
 publisher = {ACM},
 address = {New York, NY, USA},
 keywords = {Java PathFinder, debugging, software engineering, symbolic pathFinder},
} 


@article{Visser:2004:TIG:1013886.1007526,
 author = {Visser, Willem and P\v{a}s\v{a}reanu, Corina S. and Khurshid, Sarfraz},
 title = {Test Input Generation with {Java PathFinder}},
 journal = {SIGSOFT Softw. Eng. Notes},
 issue_date = {July 2004},
 volume = {29},
 number = {4},
 month = jul,
 year = {2004},
 issn = {0163-5948},
 pages = {97--107},
 numpages = {11},
 url = {http://doi.acm.org/10.1145/1013886.1007526},
 doi = {10.1145/1013886.1007526},
 acmid = {1007526},
 publisher = {ACM},
 address = {New York, NY, USA},
 keywords = {coverage, model checking, red-black trees, symbolic execution, testing object-oriented programs},
} 


% * Evenly distributed inputs
@inproceedings{Chen:2004:ART:2105774.2105800,
 author = {Chen, T. Y. and Leung, H. and Mak, I. K.},
 title = {Adaptive Random Testing},
 booktitle = {Proceedings of the 9th Asian Computing Science Conference on Advances in Computer Science: Dedicated to Jean-Louis Lassez on the Occasion of His 5th Cycle Birthday},
 series = {ASIAN'04},
 year = {2004},
 isbn = {3-540-24087-X, 978-3-540-24087-7},
 location = {Chiang Mai, Thailand},
 pages = {320--329},
 numpages = {10},
 url = {http://dx.doi.org/10.1007/978-3-540-30502-6_23},
 doi = {10.1007/978-3-540-30502-6_23},
 acmid = {2105800},
 publisher = {Springer-Verlag},
 address = {Berlin, Heidelberg},
} 

@article{levenshtein1966bcc,
  added-at = {2008-03-15T10:37:17.000+0100},
  author = {Levenshtein, VI},
  biburl = {http://www.bibsonomy.org/bibtex/21a29b294552edb63828d57f3495e2eb2/brightbyte},
  interhash = {55f7ad93fcb9ae3ed999afaa6e24937d},
  intrahash = {1a29b294552edb63828d57f3495e2eb2},
  journal = {Soviet Physics Doklady},
  keywords = {lexicography similarity},
  pages = 707,
  timestamp = {2008-03-15T10:37:17.000+0100},
  title = {{Binary Codes Capable of Correcting Deletions, Insertions and Reversals}},
  volume = 10,
  year = 1966
}



%JPPA
@inproceedings{Salcianu:2005:PSE:2131753.2131773,
 author = {S\u{a}lcianu, Alexandru and Rinard, Martin},
 title = {Purity and Side Effect Analysis for {Java} Programs},
 booktitle = {Proceedings of the 6th International Conference on Verification, Model Checking, and Abstract Interpretation},
 series = {VMCAI'05},
 year = {2005},
 isbn = {3-540-24297-X, 978-3-540-24297-0},
 location = {Paris, France},
 pages = {199--215},
 numpages = {17},
 url = {http://dx.doi.org/10.1007/978-3-540-30579-8_14},
 doi = {10.1007/978-3-540-30579-8_14},
 acmid = {2131773},
 publisher = {Springer-Verlag},
 address = {Berlin, Heidelberg},
} 

%Javariﬁer
@inproceedings{Tschantz:2005:JAR:1094811.1094828,
 author = {Tschantz, Matthew S. and Ernst, Michael D.},
 title = {Javari: Adding Reference Immutability to {Java}},
 booktitle = {Proceedings of the 20th Annual ACM SIGPLAN Conference on Object-oriented Programming, Systems, Languages, and Applications},
 series = {OOPSLA '05},
 year = {2005},
 isbn = {1-59593-031-0},
 location = {San Diego, CA, USA},
 pages = {211--230},
 numpages = {20},
 url = {http://doi.acm.org/10.1145/1094811.1094828},
 doi = {10.1145/1094811.1094828},
 acmid = {1094828},
 publisher = {ACM},
 address = {New York, NY, USA},
 keywords = {Java, Javari, assignable, immutability, mutable, readonly, type system, verification},
} 


%ReImInfer
@article{Huang:2012:RRC:2398857.2384680,
 author = {Huang, Wei and Milanova, Ana and Dietl, Werner and Ernst, Michael D.},
 title = {Reim \& {ReImInfer}: Checking and Inference of Reference Immutability and Method Purity},
 journal = {SIGPLAN Not.},
 issue_date = {October 2012},
 volume = {47},
 number = {10},
 month = oct,
 year = {2012},
 issn = {0362-1340},
 pages = {879--896},
 numpages = {18},
 url = {http://doi.acm.org/10.1145/2398857.2384680},
 doi = {10.1145/2398857.2384680},
 acmid = {2384680},
 publisher = {ACM},
 address = {New York, NY, USA},
 keywords = {inference, method purity, reference immutability, type system},
} 

@inproceedings{Andrews:2006:TSR:1145735.1145741,
  author = {Andrews, James H. and Haldar, Susmita and Lei, Yong and Li, Felix Chun Hang},
  title = {Tool Support for Randomized Unit Testing},
  booktitle = {Proceedings of the 1st International Workshop on Random Testing},
  series = {RT '06},
  year = {2006},
  isbn = {1-59593-457-X},
  location = {Portland, Maine},
  pages = {36--45},
  numpages = {10},
  url = {http://doi.acm.org/10.1145/1145735.1145741},
  doi = {10.1145/1145735.1145741},
  acmid = {1145741},
  publisher = {ACM},
  address = {New York, NY, USA},
  keywords = {randomized testing, unit testing},
}

@MISC{Zeller:JPURE2007,
  author = {{Valentin Dallmeier, Christian Lindig, Andreas Zeller}},
  title = {{Dynamic purity analysis for {Java} programs, https://www.st.cs.uni-saarland.de/models/jpure/}},
  year = {2007},
}


@inproceedings{Wong:2004:EMX:967900.968128,
 author = {Wong, Eugene Y. C. and Chan, Alvin T. S. and Leong, Hong-Va},
 title = {Efficient Management of XML Contents over Wireless Environment by Xstream},
 booktitle = {Proceedings of the 2004 ACM Symposium on Applied Computing},
 series = {SAC '04},
 year = {2004},
 isbn = {1-58113-812-1},
 location = {Nicosia, Cyprus},
 pages = {1122--1127},
 numpages = {6},
 url = {http://doi.acm.org/10.1145/967900.968128},
 doi = {10.1145/967900.968128},
 acmid = {968128},
 publisher = {ACM},
 address = {New York, NY, USA},
 keywords = {XML, fragmentation, mobile computing, streaming, wireless},
} 

@inproceedings{Xu:2007:DPA:1251535.1251548,
 author = {Xu, Haiying and Pickett, Christopher J. F. and Verbrugge, Clark},
 title = {Dynamic Purity Analysis for {Java} Programs},
 booktitle = {Proceedings of the 7th ACM SIGPLAN-SIGSOFT Workshop on Program Analysis for Software Tools and Engineering},
 series = {PASTE '07},
 year = {2007},
 isbn = {978-1-59593-595-3},
 location = {San Diego, California, USA},
 pages = {75--82},
 numpages = {8},
 url = {http://doi.acm.org/10.1145/1251535.1251548},
 doi = {10.1145/1251535.1251548},
 acmid = {1251548},
 publisher = {ACM},
 address = {New York, NY, USA},
 keywords = {Java, dynamic analysis, escape analysis, memoization, purity, side effects, software metrics},
}

@inproceedings{Vallee-Rai:1999:SJB:781995.782008,
 author = {Vall{\'e}e-Rai, Raja and Co, Phong and Gagnon, Etienne and Hendren, Laurie and Lam, Patrick and Sundaresan, Vijay},
 title = {Soot---a {Java} Bytecode Optimization Framework},
 booktitle = {Proceedings of the 1999 Conference of the Centre for Advanced Studies on Collaborative Research},
 series = {CASCON '99},
 year = {1999},
 location = {Mississauga, Ontario, Canada},
 pages = {13--},
 url = {http://dl.acm.org/citation.cfm?id=781995.782008},
 acmid = {782008},
 publisher = {IBM Press},
} 

@inproceedings{Vermorel:2005:MBA:2130928.2130972,
 author = {Vermorel, Joann\`{e}s and Mohri, Mehryar},
 title = {Multi-armed Bandit Algorithms and Empirical Evaluation},
 booktitle = {Proceedings of the 16th European Conference on Machine Learning},
 series = {ECML'05},
 year = {2005},
 isbn = {3-540-29243-8, 978-3-540-29243-2},
 location = {Porto, Portugal},
 pages = {437--448},
 numpages = {12},
 url = {http://dx.doi.org/10.1007/11564096_42},
 doi = {10.1007/11564096_42},
 acmid = {2130972},
 publisher = {Springer-Verlag},
 address = {Berlin, Heidelberg},
} 



%Start from here
%Thourough survey on automated test case generation
@article{Anand:2013:OSM:2503903.2503991,
 author = {Anand, Saswat and Burke, Edmund K. and Chen, Tsong Yueh and Clark, John and Cohen, Myra B. and Grieskamp, Wolfgang and Harman, Mark and Harrold, Mary Jean and Mcminn, Phil},
 title = {An Orchestrated Survey of Methodologies for Automated Software Test Case Generation},
 journal = {J. Syst. Softw.},
 issue_date = {August, 2013},
 volume = {86},
 number = {8},
 month = aug,
 year = {2013},
 issn = {0164-1212},
 pages = {1978--2001},
 numpages = {24},
 url = {http://dx.doi.org/10.1016/j.jss.2013.02.061},
 doi = {10.1016/j.jss.2013.02.061},
 acmid = {2503991},
 publisher = {Elsevier Science Inc.},
 address = {New York, NY, USA},
 keywords = {Adaptive random testing, Combinatorial testing, Model-based testing, Orchestrated survey, Search-based software testing, Software testing, Symbolic execution, Test automation, Test case generation},
} 

@article{McMinn:2004:SST:1077276.1077279,
 author = {McMinn, Phil},
 title = {Search-based Software Test Data Generation: A Survey: Research Articles},
 journal = {Softw. Test. Verif. Reliab.},
 issue_date = {June 2004},
 volume = {14},
 number = {2},
 month = jun,
 year = {2004},
 issn = {0960-0833},
 pages = {105--156},
 numpages = {52},
 url = {http://dx.doi.org/10.1002/stvr.v14:2},
 doi = {10.1002/stvr.v14:2},
 acmid = {1077279},
 publisher = {John Wiley and Sons Ltd.},
 address = {Chichester, UK},
 keywords = {automated software test data generation, evolutionary algorithms, evolutionary testing, metaheuristic search, search-based software engineering, simulated annealing},
} 

@article{Pasareanu:2009,
 author = {Pasareanu, Corina S. and Visser, Willem},
 title = {A Survey of New Trends in Symbolic Execution for Software Testing and Analysis},
 journal = {Int. J. Softw. Tools Technol. Transf.},
 issue_date = {October 2009},
 volume = {11},
 number = {4},
 month = oct,
 year = {2009},
 issn = {1433-2779},
 pages = {339--353},
 numpages = {15},
 url = {http://dx.doi.org/10.1007/s10009-009-0118-1},
 doi = {10.1007/s10009-009-0118-1},
 acmid = {1667869},
 publisher = {Springer-Verlag},
 address = {Berlin, Heidelberg},
} 

%OCAT
@inproceedings{Jaygarl:2010:OOC:1831708.1831729,
 author = {Jaygarl, Hojun and Kim, Sunghun and Xie, Tao and Chang, Carl K.},
 title = {OCAT: Object Capture-based Automated Testing},
 booktitle = {Proceedings of the 19th International Symposium on Software Testing and Analysis},
 series = {ISSTA '10},
 year = {2010},
 isbn = {978-1-60558-823-0},
 location = {Trento, Italy},
 pages = {159--170},
 numpages = {12},
 url = {http://doi.acm.org/10.1145/1831708.1831729},
 doi = {10.1145/1831708.1831729},
 acmid = {1831729},
 publisher = {ACM},
 address = {New York, NY, USA},
 keywords = {automated testing, object capturing, object generation, object mutation},
}

%TestEra
% * Direct-manipulation
% * Use Alloy as program modeling

@inproceedings{Marinov:2001:TNF:872023.872551,
 author = {Marinov, Darko and Khurshid, Sarfraz},
 title = {TestEra: A Novel Framework for Automated Testing of Java Programs},
 booktitle = {Proceedings of the 16th IEEE International Conference on Automated Software Engineering},
 series = {ASE '01},
 year = {2001},
 pages = {22--},
 url = {http://dl.acm.org/citation.cfm?id=872023.872551},
 acmid = {872551},
 publisher = {IEEE Computer Society},
 address = {Washington, DC, USA},
}


@article{Fraser:2013:WTS:2478542.2478706,
 author = {Fraser, Gordon and Arcuri, Andrea},
 title = {Whole Test Suite Generation},
 journal = {IEEE Trans. Softw. Eng.},
 issue_date = {February 2013},
 volume = {39},
 number = {2},
 month = feb,
 year = {2013},
 issn = {0098-5589},
 pages = {276--291},
 numpages = {16},
 url = {http://dx.doi.org/10.1109/TSE.2012.14},
 doi = {10.1109/TSE.2012.14},
 acmid = {2478706},
 publisher = {IEEE Press},
 address = {Piscataway, NJ, USA},
 keywords = {Software,Genetic algorithms,Search problems,Arrays,Genetic programming,Software testing,collateral coverage,Search-based software engineering,length,branch coverage,genetic algorithm,infeasible goal},
} 

@inproceedings{Fraser:2011:EAT:2025113.2025179,
 author = {Fraser, Gordon and Arcuri, Andrea},
 title = {EvoSuite: Automatic Test Suite Generation for Object-oriented Software},
 booktitle = {Proceedings of the 19th ACM SIGSOFT Symposium and the 13th European Conference on Foundations of Software Engineering},
 series = {ESEC/FSE '11},
 year = {2011},
 isbn = {978-1-4503-0443-6},
 location = {Szeged, Hungary},
 pages = {416--419},
 numpages = {4},
 url = {http://doi.acm.org/10.1145/2025113.2025179},
 doi = {10.1145/2025113.2025179},
 acmid = {2025179},
 publisher = {ACM},
 address = {New York, NY, USA},
 keywords = {assertion generation, search based soft- ware testing, test case generation},
}

%CUTE and jCUTE
@inproceedings{Sen:2006:CJC:2135909.2135962,
 author = {Sen, Koushik and Agha, Gul},
 title = {CUTE and jCUTE: Concolic Unit Testing and Explicit Path Model-checking Tools},
 booktitle = {Proceedings of the 18th International Conference on Computer Aided Verification},
 series = {CAV'06},
 year = {2006},
 isbn = {3-540-37406-X, 978-3-540-37406-0},
 location = {Seattle, WA},
 pages = {419--423},
 numpages = {5},
 url = {http://dx.doi.org/10.1007/11817963_38},
 doi = {10.1007/11817963_38},
 acmid = {2135962},
 publisher = {Springer-Verlag},
 address = {Berlin, Heidelberg},
} 


@inproceedings{Xie:2005:SFG:2140653.2140685,
 author = {Xie, Tao and Marinov, Darko and Schulte, Wolfram and Notkin, David},
 title = {Symstra: A Framework for Generating Object-oriented Unit Tests Using Symbolic Execution},
 booktitle = {Proceedings of the 11th International Conference on Tools and Algorithms for the Construction and Analysis of Systems},
 series = {TACAS'05},
 year = {2005},
 isbn = {3-540-25333-5, 978-3-540-25333-4},
 location = {Edinburgh, UK},
 pages = {365--381},
 numpages = {17},
 url = {http://dx.doi.org/10.1007/978-3-540-31980-1_24},
 doi = {10.1007/978-3-540-31980-1_24},
 acmid = {2140685},
 publisher = {Springer-Verlag},
 address = {Berlin, Heidelberg},
} 


@inproceedings{Thummalapenta:2011:SMS:2048066.2048083,
 author = {Thummalapenta, Suresh and Xie, Tao and Tillmann, Nikolai and de Halleux, Jonathan and Su, Zhendong},
 title = {Synthesizing Method Sequences for High-coverage Testing},
 booktitle = {Proceedings of the 2011 ACM International Conference on Object Oriented Programming Systems Languages and Applications},
 series = {OOPSLA '11},
 year = {2011},
 isbn = {978-1-4503-0940-0},
 location = {Portland, Oregon, USA},
 pages = {189--206},
 numpages = {18},
 url = {http://doi.acm.org/10.1145/2048066.2048083},
 doi = {10.1145/2048066.2048083},
 acmid = {2048083},
 publisher = {ACM},
 address = {New York, NY, USA},
 keywords = {object-oriented testing, symbolic execution},
} 


% * Integrate evolutionary testing and symbolic execution
% * Use evolutionary techniques to generate method sequences
% * Use symbolic execution to generate method inputs
@inproceedings{Inkumsah:2008:IST:1642931.1642967,
 author = {Inkumsah, K. and Tao Xie},
 title = {Improving Structural Testing of Object-Oriented Programs via Integrating Evolutionary Testing and Symbolic Execution},
 booktitle = {Proceedings of the 2008 23rd IEEE/ACM International Conference on Automated Software Engineering},
 series = {ASE '08},
 year = {2008},
 isbn = {978-1-4244-2187-9},
 pages = {297--306},
 numpages = {10},
 url = {http://dx.doi.org/10.1109/ASE.2008.40},
 doi = {10.1109/ASE.2008.40},
 acmid = {1642967},
 publisher = {IEEE Computer Society},
 address = {Washington, DC, USA},
 keywords = {random testing, structural testing, object-oriented programs, evolutionary testing, symbolic execution, high structural coverage, branch coverage, complex program logics, Evacon, white-box test generation tools},
} 


@inproceedings{Malburg:2011:CSC:2190078.2190094,
 author = {Malburg, Jan and Fraser, Gordon},
 title = {Combining Search-based and Constraint-based Testing},
 booktitle = {Proceedings of the 2011 26th IEEE/ACM International Conference on Automated Software Engineering},
 series = {ASE '11},
 year = {2011},
 isbn = {978-1-4577-1638-6},
 pages = {436--439},
 numpages = {4},
 url = {http://dx.doi.org/10.1109/ASE.2011.6100092},
 doi = {10.1109/ASE.2011.6100092},
 acmid = {2190094},
 publisher = {IEEE Computer Society},
 address = {Washington, DC, USA},
} 


@inproceedings{Zhang:2011:CSD:2001420.2001463,
 author = {Zhang, Sai and Saff, David and Bu, Yingyi and Ernst, Michael D.},
 title = {Combined Static and Dynamic Automated Test Generation},
 booktitle = {Proceedings of the 2011 International Symposium on Software Testing and Analysis},
 series = {ISSTA '11},
 year = {2011},
 isbn = {978-1-4503-0562-4},
 location = {Toronto, Ontario, Canada},
 pages = {353--363},
 numpages = {11},
 url = {http://doi.acm.org/10.1145/2001420.2001463},
 doi = {10.1145/2001420.2001463},
 acmid = {2001463},
 publisher = {ACM},
 address = {New York, NY, USA},
 keywords = {automated test generation, dynamic analyses, static},
} 


@inproceedings{Pradel:2012:LTG:2337223.2337258,
 author = {Pradel, Michael and Gross, Thomas R.},
 title = {Leveraging Test Generation and Specification Mining for Automated Bug Detection Without False Positives},
 booktitle = {Proceedings of the 34th International Conference on Software Engineering},
 series = {ICSE '12},
 year = {2012},
 isbn = {978-1-4673-1067-3},
 location = {Zurich, Switzerland},
 pages = {288--298},
 numpages = {11},
 url = {http://dl.acm.org/citation.cfm?id=2337223.2337258},
 acmid = {2337258},
 publisher = {IEEE Press},
 address = {Piscataway, NJ, USA},
} 


%compsac 09
@INPROCEEDINGS{5254269, 
author={Jaygarl, H. and Chang, C.K. and Sunghun Kim}, 
booktitle={Computer Software and Applications Conference, 2009. COMPSAC '09. 33rd Annual IEEE International}, 
title={Practical Extensions of a Randomized Testing Tool}, 
year={2009}, 
month={July}, 
volume={1}, 
pages={148-153}, 
keywords={object-oriented programming;program testing;software tools;object-oriented software;randomized testing tool;state-of-the-art random test algorithm;Application software;Automatic testing;Computer applications;Computer science;Java;Large-scale systems;Software algorithms;Software testing;Software tools;Writing;Adaptive Random Testing;Automated Test Generation}, 
doi={10.1109/COMPSAC.2009.29}, 
ISSN={0730-3157},}

%compsac 10, cite it???
@inproceedings{Jaygarl:2010:GTG:1901613.1902041,
 author = {Jaygarl, Hojun and Lu, Kai-Shin and Chang, Carl K.},
 title = {GenRed: A Tool for Generating and Reducing Object-Oriented Test Cases},
 booktitle = {Proceedings of the 2010 IEEE 34th Annual Computer Software and Applications Conference},
 series = {COMPSAC '10},
 year = {2010},
 isbn = {978-0-7695-4085-6},
 pages = {127--136},
 numpages = {10},
 url = {http://dx.doi.org/10.1109/COMPSAC.2010.19},
 doi = {10.1109/COMPSAC.2010.19},
 acmid = {1902041},
 publisher = {IEEE Computer Society},
 address = {Washington, DC, USA},
 keywords = {Adaptive Random Testing, Automated Test Generation, Test Suite Reduction},
} 

% * Use genetic algorithm to generate method call sequences
@inproceedings{Tonella:2004:ETC:1007512.1007528,
 author = {Tonella, Paolo},
 title = {Evolutionary Testing of Classes},
 booktitle = {Proceedings of the 2004 ACM SIGSOFT International Symposium on Software Testing and Analysis},
 series = {ISSTA '04},
 year = {2004},
 isbn = {1-58113-820-2},
 location = {Boston, Massachusetts, USA},
 pages = {119--128},
 numpages = {10},
 url = {http://doi.acm.org/10.1145/1007512.1007528},
 doi = {10.1145/1007512.1007528},
 acmid = {1007528},
 publisher = {ACM},
 address = {New York, NY, USA},
 keywords = {automated test case generation, genetic algorithms, object-oriented testing},
} 

@inproceedings{Fraser:2012:SEE:2337223.2337245,
 author = {Fraser, Gordon and Arcuri, Andrea},
 title = {Sound Empirical Evidence in Software Testing},
 booktitle = {Proceedings of the 34th International Conference on Software Engineering},
 series = {ICSE '12},
 year = {2012},
 isbn = {978-1-4673-1067-3},
 location = {Zurich, Switzerland},
 pages = {178--188},
 numpages = {11},
 url = {http://dl.acm.org/citation.cfm?id=2337223.2337245},
 acmid = {2337245},
 publisher = {IEEE Press},
 address = {Piscataway, NJ, USA},
} 


@inproceedings{Xie:2004:RFD:1025115.1025219,
 author = {Xie, Tao and Marinov, Darko and Notkin, David},
 title = {Rostra: A Framework for Detecting Redundant Object-Oriented Unit Tests},
 booktitle = {Proceedings of the 19th IEEE International Conference on Automated Software Engineering},
 series = {ASE '04},
 year = {2004},
 isbn = {0-7695-2131-2},
 pages = {196--205},
 numpages = {10},
 url = {http://dx.doi.org/10.1109/ASE.2004.61},
 doi = {10.1109/ASE.2004.61},
 acmid = {1025219},
 publisher = {IEEE Computer Society},
 address = {Washington, DC, USA},
} 


@inproceedings{Tillmann:2008:PWB:1792786.1792798,
 author = {Tillmann, Nikolai and De Halleux, Jonathan},
 title = {Pex: White Box Test Generation for .NET},
 booktitle = {Proceedings of the 2Nd International Conference on Tests and Proofs},
 series = {TAP'08},
 year = {2008},
 isbn = {3-540-79123-X, 978-3-540-79123-2},
 location = {Prato, Italy},
 pages = {134--153},
 numpages = {20},
 url = {http://dl.acm.org/citation.cfm?id=1792786.1792798},
 acmid = {1792798},
 publisher = {Springer-Verlag},
 address = {Berlin, Heidelberg},
} 

@inproceedings{Baresi:2010:TAU:1810295.1810353,
 author = {Baresi, Luciano and Miraz, Matteo},
 title = {TestFul: Automatic Unit-test Generation for Java Classes},
 booktitle = {Proceedings of the 32Nd ACM/IEEE International Conference on Software Engineering - Volume 2},
 series = {ICSE '10},
 year = {2010},
 isbn = {978-1-60558-719-6},
 location = {Cape Town, South Africa},
 pages = {281--284},
 numpages = {4},
 url = {http://doi.acm.org/10.1145/1810295.1810353},
 doi = {10.1145/1810295.1810353},
 acmid = {1810353},
 publisher = {ACM},
 address = {New York, NY, USA},
 keywords = {Java classes, search-based testing, test generation},
} 

@ARTICLE{6044587, 
author={Dallmeier, V. and Knopp, N. and Mallon, C. and Fraser, G. and Hack, S. and Zeller, A.}, 
journal={Software Engineering, IEEE Transactions on}, 
title={Automatically Generating Test Cases for Specification Mining}, 
year={2012}, 
month={March}, 
volume={38}, 
number={2}, 
pages={243-257}, 
keywords={Java;automatic test pattern generation;data mining;formal specification;program verification;Java;TAUTOKO;automatic test case generation;dynamic specification mining;normal program behavior;program executions;static typestate verifier;typestate mining;Fault detection;Heuristic algorithms;Instruments;Java;Schedules;Software;Testing;Specification mining;test case generation;typestate analysis.}, 
doi={10.1109/TSE.2011.105}, 
ISSN={0098-5589},}

@inproceedings{Jaygarl:2010:GTG,
 author = {Jaygarl, Hojun and Lu, Kai-Shin and Chang, Carl K.},
 title = {GenRed: A Tool for Generating and Reducing Object-Oriented Test Cases},
 booktitle = {Proceedings of the 2010 IEEE 34th Annual Computer Software and Applications Conference},
 series = {COMPSAC '10},
 year = {2010},
 isbn = {978-0-7695-4085-6},
 pages = {127--136},
 numpages = {10},
 url = {http://dx.doi.org/10.1109/COMPSAC.2010.19},
 doi = {10.1109/COMPSAC.2010.19},
 acmid = {1902041},
 publisher = {IEEE Computer Society},
 address = {Washington, DC, USA},
 keywords = {Adaptive Random Testing, Automated Test Generation, Test Suite Reduction},
} 

